with Interfaces; use Interfaces;

package body CORBA_Repository_Root_PrimitiveDef_Hash is

   P : constant array (0 .. 2) of Natural :=
     (2, 4, 6);

   T1 : constant array (0 .. 2) of Unsigned_8 :=
     (17, 17, 8);

   T2 : constant array (0 .. 2) of Unsigned_8 :=
     (10, 6, 10);

   G : constant array (0 .. 18) of Unsigned_8 :=
     (0, 0, 0, 0, 2, 0, 4, 7, 0, 2, 0, 0, 0, 4, 4, 0, 0, 1, 4);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 19;
         F2 := (F2 + Natural (T2 (K)) * J) mod 19;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 9;
   end Hash;

end CORBA_Repository_Root_PrimitiveDef_Hash;
